glibmm: Gio::Converter Class Reference

glibmm 2.38.1

- Main Page
- Related Pages
- Modules
- Namespaces
- Classes
- Examples

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Member Functions | Static Public Member Functions | Protected Member Functions | Related Functions | List of all members
Gio::Converter Class Reference

Converter - Data conversion interface. More...

`#include <giomm/converter.h>`

Inheritance diagram for Gio::Converter:
[legend]

## Public Member Functions
virtual | ~Converter ()
GConverter* | gobj ()
| Provides access to the underlying C GObject. More...
const GConverter* | gobj () const
| Provides access to the underlying C GObject. More...
ConverterResult | convert (const void* inbuf, gsize inbuf_size, void* outbuf, gsize outbuf_size, ConverterFlags flags, gsize& bytes_read, gsize& bytes_written)
| This is the main operation used when converting data. More...
void | reset ()
| Resets all internal state in the converter, making it behave as if it was just created. More...
virtual ConverterResult | convert_vfunc (const void* inbuf, gsize inbuf_size, void* outbuf, gsize outbuf_size, ConverterFlags flags, gsize& bytes_read, gsize& bytes_written)
virtual void | reset_vfunc ()
Public Member Functions inherited from Glib::Interface
| Interface ()
| A Default constructor. More...
| Interface (const Glib::Interface_Class& interface_class)
| Called by constructors of derived classes. More...
| Interface (GObject* castitem)
| Called by constructors of derived classes. More...
virtual | ~Interface ()
GObject* | gobj ()
const GObject* | gobj () const
Public Member Functions inherited from Glib::ObjectBase
void | set_property_value (const Glib::ustring& property_name, const Glib::ValueBase&value)
| You probably want to use a specific property_*() accessor method instead. More...
void | get_property_value (const Glib::ustring& property_name, Glib::ValueBase&value) const
| You probably want to use a specific property_*() accessor method instead. More...
template<class PropertyType >
void | set_property (const Glib::ustring& property_name, const PropertyType&value)
| You probably want to use a specific property_*() accessor method instead. More...
template<class PropertyType >
void | get_property (const Glib::ustring& property_name, PropertyType&value) const
| You probably want to use a specific property_*() accessor method instead. More...
void | connect_property_changed (const Glib::ustring& property_name, const sigc::slot< void >& slot)
| You can use the signal_changed() signal of the property proxy instead, but this is necessary when using the reduced API. More...
sigc::connection | connect_property_changed_with_return (const Glib::ustring& property_name, const sigc::slot< void >& slot)
| You can use the signal_changed() signal of the property proxy instead, but this is necessary when using the reduced API. More...
void | freeze_notify ()
| Increases the freeze count on object. More...
void | thaw_notify ()
| Reverts the effect of a previous call to freeze_notify(). More...
virtual void | reference () const
| Increment the reference count for this object. More...
virtual void | unreference () const
| Decrement the reference count for this object. More...
GObject* | gobj ()
| Provides access to the underlying C GObject. More...
const GObject* | gobj () const
| Provides access to the underlying C GObject. More...
GObject* | gobj_copy () const
| Give a ref-ed copy to someone. Use for direct struct access. More...

## Static Public Member Functions
static void | add_interface (GType gtype_implementer)
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system. More...

## Protected Member Functions
| Converter ()
| You should derive from this class to use it. More...

## Related Functions
(Note that these are not member functions.)
Glib::RefPtr< Gio::Converter > | wrap (GConverter* object, bool take_copy=false)
| A Glib::wrap() method for this object. More...

## Detailed Description

Converter - Data conversion interface.

Converter is implemented by objects that convert binary data in various ways. The conversion can be stateful and may fail at any place.

Some example conversions are: character set conversion, compression, decompression and regular expression replace.

Since glibmm 2.34:

## Constructor & Destructor Documentation

Gio::Converter::Converter | ( |  | ) |
| protected

You should derive from this class to use it.

virtual Gio::Converter::~Converter | ( |  | ) |
| virtual

## Member Function Documentation

static void Gio::Converter::add_interface | ( | GType | gtype_implementer | ) |
| static

ConverterResult Gio::Converter::convert | ( | const void * | inbuf,
|  | gsize | inbuf_size,
|  | void * | outbuf,
|  | gsize | outbuf_size,
|  | ConverterFlags | flags,
|  | gsize & | bytes_read,
|  | gsize & | bytes_written
| ) |  |

This is the main operation used when converting data.

It is to be called multiple times in a loop, and each time it will do some work, i.e. producing some output (in outbuf) or consuming some input (from inbuf) or both. If its not possible to do any work an error is returned.

Note that a single call may not consume all input (or any input at all). Also a call may produce output even if given no input, due to state stored in the converter producing output.

If any data was either produced or consumed, and then an error happens, then only the successful conversion is reported and the error is returned on the next call.

A full conversion loop involves calling this method repeatedly, each time giving it new input and space output space. When there is no more input data after the data in inbuf, the flag CONVERTER_INPUT_AT_END must be set. The loop will be (unless some error happens) returning CONVERTER_CONVERTED each time until all data is consumed and all output is produced, then CONVERTER_FINISHED is returned instead. Note, that CONVERTER_FINISHED may be returned even if CONVERTER_INPUT_AT_END is not set, for instance in a decompression converter where the end of data is detectable from the data (and there might even be other data after the end of the compressed data).

When some data has successfully been converted bytes_read and is set to the number of bytes read from inbuf, and bytes_written is set to indicate how many bytes was written to outbuf. If there are more data to output or consume (i.e. unless the CONVERTER_INPUT_AT_END is specified) then CONVERTER_CONVERTED is returned, and if no more data is to be output then CONVERTER_FINISHED is returned.

On error CONVERTER_ERROR is returned and error is set accordingly. Some errors need special handling:

IO_ERROR_NO_SPACE is returned if there is not enough space to write the resulting converted data, the application should call the function again with a larger outbuf to continue.

IO_ERROR_PARTIAL_INPUT is returned if there is not enough input to fully determine what the conversion should produce, and the CONVERTER_INPUT_AT_END flag is not set. This happens for example with an incomplete multibyte sequence when converting text, or when a regexp matches up to the end of the input (and may match further input). It may also happen when inbuf_size is zero and there is no more data to produce.

When this happens the application should read more input and then call the function again. If further input shows that there is no more data call the function again with the same data but with the CONVERTER_INPUT_AT_END flag set. This may cause the conversion to finish as e.g. in the regexp match case (or, to fail again with IO_ERROR_PARTIAL_INPUT in e.g. a charset conversion where the input is actually partial).

After g_converter_convert() has returned CONVERTER_FINISHED the converter object is in an invalid state where its not allowed to call g_converter_convert() anymore. At this time you can only free the object or call g_converter_reset() to reset it to the initial state.

If the flag CONVERTER_FLUSH is set then conversion is modified to try to write out all internal state to the output. The application has to call the function multiple times with the flag set, and when the available input has been consumed and all internal state has been produced then CONVERTER_FLUSHED (or CONVERTER_FINISHED if really at the end) is returned instead of CONVERTER_CONVERTED. This is somewhat similar to what happens at the end of the input stream, but done in the middle of the data.

This has different meanings for different conversions. For instance in a compression converter it would mean that we flush all the compression state into output such that if you uncompress the compressed data you get back all the input data. Doing this may make the final file larger due to padding though. Another example is a regexp conversion, where if you at the end of the flushed data have a match, but there is also a potential longer match. In the non-flushed case we would ask for more input, but when flushing we treat this as the end of input and do the match.

Flushing is not always possible (like if a charset converter flushes at a partial multibyte sequence). Converters are supposed to try to produce as much output as possible and then return an error (typically IO_ERROR_PARTIAL_INPUT).

Since glibmm 2.24:

Parameters

  inbuf | The buffer containing the data to convert.
  inbuf_size | The number of bytes in inbuf.
  outbuf | A buffer to write converted data in.
  outbuf_size | The number of bytes in outbuf, must be at least one.
  flags | A ConverterFlags controlling the conversion details.
  bytes_read | Will be set to the number of bytes read from inbuf on success.
  bytes_written | Will be set to the number of bytes written to outbuf on success.

Returns
  A ConverterResult, CONVERTER_ERROR on error.

virtual ConverterResult Gio::Converter::convert_vfunc | ( | const void * | inbuf,
|  | gsize | inbuf_size,
|  | void * | outbuf,
|  | gsize | outbuf_size,
|  | ConverterFlags | flags,
|  | gsize & | bytes_read,
|  | gsize & | bytes_written
| ) |  |
| virtual

Exceptions

  Glib::Error. |

static GType Gio::Converter::get_type | ( |  | ) |
| static

Get the GType for this class, for use with the underlying GObject type system.

GConverter* Gio::Converter::gobj | ( |  | ) |
| inline

Provides access to the underlying C GObject.

const GConverter* Gio::Converter::gobj | ( |  | ) | const
| inline

Provides access to the underlying C GObject.

void Gio::Converter::reset | ( |  | ) |

Resets all internal state in the converter, making it behave as if it was just created.

If the converter has any internal state that would produce output then that output is lost.

Since glibmm 2.24:

virtual void Gio::Converter::reset_vfunc | ( |  | ) |
| virtual

## Friends And Related Function Documentation

Glib::RefPtr< Gio::Converter > wrap | ( | GConverter * | object,
|  | bool | take_copy = `false`
| ) |  |
| related

A Glib::wrap() method for this object.

Parameters

  object | The C instance.
  take_copy | False if the result should take ownership of the C instance. True if it should take a new copy or ref.

Returns
  A C++ instance that wraps this C instance.